// ClassFactory.h: interface for the CClassFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(XML_CLASS_FACTORY_INCLUDE)
#define XML_CLASS_FACTORY_INCLUDE

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "tinyxml\tinyxml.h"

/*! 
   \author Juan Antonio Medina ^ mICrO ( mail<_at_>juan-medina.com )
   \mainpage Class Factorys using XML
 
   \section intro Introduction
 
  	Class Factorys using XML. 
  	
 	
 	Forgive me for my really bad English :)
 
 	This class its a implementation of something like class factory.
 
 	It's could be easy modified to make father implementations of
 	complex data structures with an easy Access System.
 
 
 	It's could be easy modified to make father implementations of
 	complex data structures with an easy Access System.
 
   \section format Formats
 
 	XML Classes Definitions Format : 
 	\verbatim
	<classes>
		<class name="className" extends="parentClass">
			<attribute name="attriButeName"/>
			...
		</class>
		...
	</classes>
	\endverbatim
	Example : 
	\verbatim
	<classes>
		<class name="vehicle">
			<attribute name="color"/>
			<attribute name="model"/>
			<attribute name="fabricant"/>
		</class>
		<class name="car" extends="vehicle">
			<attribute name="wheels"/>
			<attribute name="air-condition"/>
		</class>
		<class name="bus" extends="car">
			<attribute name="paxes"/>
		</class>
		<class name="plane" extends="vehicle">
			<attribute name="turbines"/>
		</class>
	</classes>
	\endverbatim
	XML Objects Instaces Context Format : 
	\verbatim
	<instances>
		<instance class="className" name="instaceName">
			<attributeName>value</attributeName>
			...
		</instance>
		...
	</instances>
	\endverbatim
	Example :
	\verbatim
	<instances>
		<instance class="car" name="car118256553">
			<wheels>3</wheels>
			<air-condition>no</air-condition>
			<color>red</color>
			<model>huge</model>
			<fabricant />
		</instance>
		<instance class="bus" name="bus118260529">
			<paxes>55</paxes>
			<wheels>12</wheels>
			<air-condition>yes</air-condition>
			<color>blue</color>
			<model />
			<fabricant />
		</instance>
	</instances>
	\endverbatim
 *
 */



//!  Class Factorys using XML. 
/*!

	This class its a implementation of something like class factory.

*/
class CClassFactory  
{
public:	

	/* INITIALIZATION ****/

	//! Default constructor
	/*!
		Default constructor
	*/
	CClassFactory();

	//! Default destructor
	/*!
		Default destructor
	*/
	virtual ~CClassFactory();


	//! Clear current classes definitions
	/*!
		Clear current classes definitions
	*/
	void clearClasDef();


	//! Clear current context
	/*!
		Clear current context
	*/
	void clearCurContext();

	/* CLASS MANIPULATION ****/

	//! add a new Class Definitions to the class Factory
	/*!
		You should call this method to add new Class Definition to the Class
		Factory.

		\param className = class name for the new class definition
		\param extends = parent class, NULL if we dont set it
		\return true if the operations was valid
		\sa deleteClass
		\sa findClass
	*/
	bool addClass (const char * className, const char* extends);


	//! find a particular class in the clasess Definitions of the class Factory
	/*!
		You should call this method to find a class definition giving a class
		name.

		\param className = class name that you searching for
		
		\return an TiXmlNode pointer represents the class, NULL if we couldn't
		find it
		\sa addClass
		\sa deleteClass
	*/
	TiXmlNode* findClass(const char* className);


	//! delete a particular class in the clasess Definitions
	/*!
		You should call this method to delete a class definition giving a class
		name.

		\param className = class name that you want to delete
		
		\return true if the operations was valid
		\sa addClass
		\sa findClass
	*/
	bool deleteClass(const char* className);

	/* ATTRIBUTE MANIPULATION ****/

	//! add a new Attribute to a giving class
	/*!
		You should call this method to add a new attribute to a giving class.

		\param className = class name that holds the attribute
		\param attributeName = attribute name for the new attribute
		\return true if the operations was valid
		\sa deleteAttribute
	*/
	bool addAttribute(const char* className, const char* attributeName);


	//! delete an Attribute from a giving class
	/*!
		You should call this method to delete an attribute from a giving class.

		\param className = class name that holds the attribute
		\param attributeName = attribute name for delete
		\return true if the operations was valid
		\sa addAttribute
	*/
	bool deleteAttribute(const char *className, const char *attributeName);

	
	/* INSTANCE MANIPULATION ****/

	//! Make a new object instace of a giving class name
	/*!
		You should call this method to add a new object instance of a giving 
		name. This method olso creates the values of the atributes of this 
		class, and uppers classes following the hirearchy..

		\param className = class name that we want to instance it
		\param instanceName = instance name for the new instance
		\return true if the operations was valid
		\sa deleteInstace
		\sa findInstance
	*/
	bool newInstance(const char * className, const char* instanceName);

	//! find an object instace of a giving class name
	/*!
		You should call this method to find an object instance of a giving 
		instace name.
		
		\param instanceName = instance name to be find
		\return an TiXmlNode pointer represents the instance, NULL if we 
		couldn't find it
		\sa deleteInstace
		\sa newInstance
	*/
	TiXmlNode* findInstance(const char * instanceName);

	//! delete an object instace of a giving instance name
	/*!
		You should call this method to delete an object instance of a giving 
		instace name.
		
		\param instanceName = instance name to be delete
		\return true if the operations was valid
		\sa newInstance
		\sa findInstance
	*/
	bool deleteInstace(const char* instanceName);

	//! Set the value of an attribute in a giving object instance
	/*!
		You should call this method to set the value of an attribute in a
		givging object instace
		
		\param instanceName = instance name of the object instance
		\param attributeName = attribute name in the object instance
		\param value = value to set
		\return true if the operations was valid
		\sa getValue
		
	*/	
	bool setValue(const char * instanceName, const char* attributeName, 
		const char* value);

	//! Get the value of an attribute in a giving object instance
	/*!
		You should call this method to get the value of an attribute in a
		givging object instace
		
		\param instanceName = instance name of the object instance
		\param attributeName = attribute name in the object instance		
		\return the value of the attribute, "" if isn't have any
		\sa setValue
		
	*/	
	CString getValue(const char * instanceName, const char* attributeName);


	/* PERSISTENCE ****/
	//! Load classes definitions from a XML / Text file
	/*!
		You should call this method to load the full classes definitions
		from a XML FILE
		
		\param filename = file to load		
		\return true if operation it's valid
		\sa saveClassDef
		
	*/	
	bool loadClassDef(const char* filename);

	//! Save classes definitions from a XML / Text file
	/*!
		You should call this method to save the full classes definitions
		to a XML FILE
		
		\param filename = file to save		
		\return true if operation it's valid
		\sa loadClassDef
		
	*/	
	bool saveClassDef(const char *filename);



	//! Load object instances context from a XML / Text file
	/*!
		You should call this method to load the full object instances context 
		from a XML FILE
		
		\param filename = file to load		
		\return true if operation it's valid
		\sa saveContext
		
	*/	
	bool loadContext(const char *filename);


	//! Save object instances context from a XML / Text file
	/*!
		You should call this method to save the full object instances context
		to a XML FILE
		
		\param filename = file to save		
		\return true if operation it's valid
		\sa loadContext
		
	*/
	bool saveContext(const char *filename);


	/* GETs ****/

	//! Get the full classes definitions as an xml dom document
	/*!
		You should call this method to get the classes definitions
		in a TiXmlDocument.
		
		
		\return an TiXmlDocument pointer to the classes definitions
		\sa getCurContext
		
	*/
	inline TiXmlDocument* getClassDef(){return &classesDefinitions;}

	//! Get the full objects instances as an xml dom document
	/*!
		You should call this method to get the objects instances
		in a TiXmlDocument.
		
		
		\return an TiXmlDocument pointer to the objects instances
		\sa getClassDef
		
	*/
	inline TiXmlDocument* getCurContext(){return &currentContext;}


private:
	
	/* ATTRIBUTES ****/

	//! XML Document with classes definitions
	/*!
		XML Document with classes definitions		
	*/
	TiXmlDocument classesDefinitions;

	//! XML Document with objects instances
	/*!
		XML Document with objects instances
	*/
	TiXmlDocument currentContext;

	/* HELPERS ****/

	//! Add the attributes of a class to a instance (INTERNAL USE)
	/*!
		This function add the attributes of desired class to a giving
		instance, this method work in recursive way to add all the
		attribute of uppers classes to the instance.

		\param element = TiXmlElement pointer represents the Instance
		\param classNode = TiXmlElement pointer represents the class definition
		\return true if operation it's valid
	*/
	bool addAttributesToInstance(TiXmlElement* element, TiXmlNode* classNode);

	//! Display an Error Message
	/*!
		Nasty function to display errors
		\param errorString = String with the error		
	*/
	void error(char message[], ...);
	

};

#endif // !defined(XML_CLASS_FACTORY_INCLUDE)
