// xmlclassDlg.h : header file
//

#if !defined(AFX_XMLCLASSDLG_H__80332494_DEEC_43F3_B230_583E3254BCDE__INCLUDED_)
#define AFX_XMLCLASSDLG_H__80332494_DEEC_43F3_B230_583E3254BCDE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ClassFactory.h"
#include "NewInstanceDlg.h"
#include "NewClassDlg.h"
#include "NewAttributeDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CXmlclassDlg dialog

class CXmlclassDlg : public CDialog
{
// Construction
public:
	void SetObjectInstaceData(CString data);
	void DrawContext(TiXmlElement* context);
	void resetUI();
	void DrawClasses(TiXmlElement* classes);
	void initControls();
	CXmlclassDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CXmlclassDlg)
	enum { IDD = IDD_XMLCLASS_DIALOG };
	CButton	m_bDeleteAttribute;
	CButton	m_bDeleteClass;
	CButton	m_bNewAttribute;
	CButton	m_bDeleteInstance;
	CTreeCtrl	m_contextTree;
	CButton	m_bNewInstance;
	CTreeCtrl	m_classTree;
	CString	m_instanceName;
	CString	m_attributeName;
	CString	m_value;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CXmlclassDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CXmlclassDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnQuit();
	afx_msg void OnLoadClasses();
	afx_msg void OnSelchangedClassesTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNewInstance();
	afx_msg void OnSelchangedContextTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteInstance();
	afx_msg void OnSetValue();
	afx_msg void OnGetValue();
	afx_msg void OnDblclkContextTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSaveClasses();
	afx_msg void OnLoadContext();
	afx_msg void OnSaveContext();
	afx_msg void OnNewClass();
	afx_msg void OnNewAttribute();
	afx_msg void OnDeleteClass();
	afx_msg void OnDeleteAttribute();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


	CImageList m_classDefImages;
	CImageList m_contextImages;

	CClassFactory classFactory;

	CNewInstanceDlg newInstanceDlg;
	CNewClassDlg newClassDlg;
	CNewAttributeDlg newAttributeDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XMLCLASSDLG_H__80332494_DEEC_43F3_B230_583E3254BCDE__INCLUDED_)
